Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h	(revision 517)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.h	(revision 519)
@@ -214,6 +214,4 @@
 	virtual float GetVolume(ViewCell *viewCell) const;
 
-	virtual AxisAlignedBox3 GetSceneBbox() const = 0;
-
 	/** Sets the current renderer mainly for view cells statistics.
 	*/
@@ -232,4 +230,6 @@
 	*/
 	void SetViewSpaceBox(const AxisAlignedBox3 &box);
+
+	AxisAlignedBox3 GetViewSpaceBox() const;
 
 	/** Creates mesh for this view cell.
@@ -365,6 +365,4 @@
 	float GetRendercost(ViewCell *viewCell, float objRendercost) const;
 
-	AxisAlignedBox3 GetSceneBbox() const;
-
 	/** Get a viewcell containing the specified point */
 	ViewCell *GetViewCell(const Vector3 &point);
@@ -442,6 +440,4 @@
 	float GetProbability(ViewCell *viewCell);
 	float GetRendercost(ViewCell *viewCell, float objRendercost) const;
-  
-	AxisAlignedBox3 GetSceneBbox() const;
 
 	void CreateMesh(ViewCell *vc);
@@ -501,6 +497,4 @@
 	float GetRendercost(ViewCell *viewCell, float objRendercost) const;
 
-	AxisAlignedBox3 GetSceneBbox() const;
-
 	void CreateMesh(ViewCell *vc);
 
@@ -556,6 +550,4 @@
 	float GetRendercost(ViewCell *viewCell, float objRendercost) const;
 	
-	AxisAlignedBox3 GetSceneBbox() const;
-	
 	ViewCell *GetViewCell(const Vector3 &point);
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 518)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 519)
@@ -321,4 +321,10 @@
 
 
+AxisAlignedBox3 ViewCellsManager::GetViewSpaceBox() const
+{
+	return mSceneBox;
+}
+
+
 void ViewCellsManager::ResetViewCells()
 {
@@ -344,7 +350,7 @@
   Ray hray(ray);
   float tmin = 0, tmax = 1.0;
-Debug << "here3" << endl;
+
   //hray.Init(ray.GetOrigin(), ray.GetDir(), Ray::LINE_SEGMENT);
-  if (!GetSceneBbox().GetRaySegment(hray, tmin, tmax) || (tmin > tmax))
+  if (!GetViewSpaceBox().GetRaySegment(hray, tmin, tmax) || (tmin > tmax))
 	return;
 
@@ -594,5 +600,5 @@
 	// compute view cell area as subsititute for probability
 #if 0
-	return GetArea(viewCell) / GetSceneBbox().SurfaceArea();
+	return GetArea(viewCell) / GetViewSpaceBox().SurfaceArea();
 #else
 	return GetArea(viewCell) / GetAccVcArea();
@@ -604,10 +610,4 @@
 {
 	return viewCell->GetPvs().GetSize() * objRendercost;
-}
-
-
-AxisAlignedBox3 BspViewCellsManager::GetSceneBbox() const
-{
-	return mBspTree->GetBoundingBox();
 }
 
@@ -1110,5 +1110,5 @@
 	// compute view cell area / volume as subsititute for probability
 #if 0
-	return GetArea(viewCell) / GetSceneBbox().SurfaceArea();
+	return GetArea(viewCell) / GetViewSpaceBox().SurfaceArea();
 #endif
 #if 1
@@ -1116,5 +1116,5 @@
 #endif
 #if 0
-	return GetVolume(viewCell) / GetSceneBbox().GetVolume();
+	return GetVolume(viewCell) / GetViewSpaceBox().GetVolume();
 #endif
 }
@@ -1127,13 +1127,9 @@
 
 
-AxisAlignedBox3 KdViewCellsManager::GetSceneBbox() const
-{
-	return mKdTree->GetBox();
-}
-
 void KdViewCellsManager::CollectViewCells()
 {
 	//mKdTree->CollectViewCells(mViewCells); TODO
 }
+
 
 int KdViewCellsManager::Construct(const ObjectContainer &objects,
@@ -1408,5 +1404,5 @@
 	// volume or area substitutes for view point probability
 #if 0
-	return GetArea(viewCell) / GetSceneBbox().SurfaceArea();
+	return GetArea(viewCell) / GetViewSpaceBox().SurfaceArea();
 #else
 	return GetArea(viewCell) / GetAccVcArea();
@@ -1495,10 +1491,4 @@
 
 	return 0;
-}
-
-
-AxisAlignedBox3 VspKdViewCellsManager::GetSceneBbox() const
-{
-	return mVspKdTree->GetBBox(mVspKdTree->GetRoot());
 }
 
@@ -1767,5 +1757,5 @@
 {
 #if 0
-	return GetArea(viewCell) / GetSceneBbox().SurfaceArea();
+	return GetArea(viewCell) / GetViewSpaceBox().SurfaceArea();
 #else
 	return GetArea(viewCell) / GetAccVcArea();
@@ -1784,10 +1774,4 @@
 {
 	return viewCell->GetPvs().GetSize() * objRendercost;
-}
-
-
-AxisAlignedBox3 VspBspViewCellsManager::GetSceneBbox() const
-{
-	return mVspBspTree->GetBoundingBox();
 }
 